<template>
    <custom-table :data="state.roles" :headers="state.headers" :pageSize="state.pageSize" :pageDisplayCount="4"
        :showButtonName="state.showButtonName" showButton="true" />
  
</template>
  
<script>
import { reactive, onMounted } from 'vue';
import CustomTable from '@/components/custom-controller/CustomTable.vue';
import RoleService from "@/services/RoleService";
import { setEncryptedList, getDecryptedList } from "@/utils/customEncryptionAndDecryption"
import eventBus from '@/plugins/eventBus';
import { Map } from '@/models/PermissionAndRoleModel.js';
export default {
    components: {
        CustomTable,
    },
    setup() {
        
        const state = reactive({
            isOpenExpiressionPanel: true,
            panel: [0, 1],
            readonly: false,
            roles: [],
            headers: ['Id', 'Adı', 'Açıklama', 'Görünen Adı', 'Durum', ''],
            pageSize: 5,
            showButtonName: "İzin Ekle"
        });

        const getAllRoles = () => {
            const rolesCache = getDecryptedList("roles")
            if (rolesCache) {
                state.roles = Map(rolesCache, 1)
            } else {
                RoleService.GetAllRoles()
                    .then(response => {
                        const roles = response.data.Response;
                        setEncryptedList(roles, "roles")
                        state.roles = Map(roles, 1)
                    })
                    .catch(error => {
                        console.log(error);
                    });
            }
        };
       

        onMounted(() => {
            getAllRoles();
            eventBus.on('table-btn', function (event) {
                console.log("ok : ", event);
            });
            eventBus.on('role-added', function () {
                getAllRoles();
            });
        });

        return {
            state
        };
    }
}
</script>
<style scoped>
@import "@/assets/styles/custom/custom-input.css";
</style>